/*

    cliptest.c

    Copyright 1997-1999 by Richard Dawe



    Demonstration of libwin's clipboard functionality



    ---



    This program is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License as published by

    the Free Software Foundation; either version 2 of the License, or

    (at your option) any later version.



    This program is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with this program; if not, write to the Free Software

    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/



/* Include files */

#include <stdio.h>

#include <stdlib.h>

#include <string.h>



#include <libwin.h>



int main (void)

{

    long clipsize;

    char *buffer;



    /* Open the clipboard, find out how much text is in it and copy it to a

       buffer */

    printf("win_clip_open() = %i\n", win_clip_open());

    printf("Clipboard text size = '%li'\n", win_clip_getsize(CF_TEXT));



    clipsize = win_clip_getsize(CF_OEMTEXT);

    printf("Clipboard OEM text size = '%li'\n", clipsize);



    if (clipsize < 256) clipsize = 256;

    buffer = malloc(clipsize * sizeof(char));

    if (buffer == NULL) fprintf(stderr, "Unable to malloc!\n");

    memset(buffer, 0, clipsize);



    printf("win_clip_getdata(CF_OEMTEXT, ...) = %i\n", win_clip_getdata(CF_OEMTEXT, buffer, clipsize));

    printf("Data: \"%s\"\n", buffer);



    /* Empty the clipboard */

    printf("win_clip_empty() = %i\n", win_clip_empty());



    /* Put a message in the clipboard - it's usually necessary to empty it

       first for this to be successful */

    if (clipsize > strlen("Hello!")) strcpy(buffer, "Hello!");

    printf("Copying \"%s\" to the clipboard...\n", buffer);

    printf("win_clip_setdata(CF_OEMTEXT, ...) = %i\n", win_clip_setdata(CF_OEMTEXT, buffer, strlen(buffer)));



    /* Done */

    printf("win_clip_close() = %i\n", win_clip_close());



    free(buffer);



    return(EXIT_SUCCESS);

}

