/*
    regtest.c
    Copyright (C) 1997-2002 by Richard Dawe

    Demonstration of libwin's registry access functions

    ---

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Include files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libwin.h>

int main (void)
{
    long hkey;
    char buffer[256];
    long buffersize = sizeof(buffer);
    long buffertype = REG_SZ;

    memset(buffer, 0, buffersize);

    /* Try and get a registry value */
    if (w95_reg_openkey(HKEY_LOCAL_MACHINE, "Network\\Logon", &hkey) != 0)
    { printf("Unable to get registry key handle!\n"); exit(0); }

    if (w95_reg_queryvalueex(hkey, "username", NULL, &buffertype, buffer, &buffersize) != 0)
    { printf("Unable to get registry key value!\n"); exit(0); }

    printf("Username = '%s'\n", buffer);

    /* This should return the same as w95_getlogon() */
    printf("w95_getlogon() returns '%s'", w95_getlogon());

    /* OK */
    return(1);
}
