/*

    vxdtest.c

    Copyright 1997-1999 by Richard Dawe



    Demonstration of libwin's VxD functions.



    ---



    This program is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License as published by

    the Free Software Foundation; either version 2 of the License, or

    (at your option) any later version.



    This program is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with this program; if not, write to the Free Software

    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/



/* Include files */

#include <dos.h>

#include <stdio.h>

#include <stdlib.h>

#include <string.h>



#include <libwin.h>



/* Some variables */

int vpicd_entry[2];

int vpicd_entry2[2];



char *VXDNAME_WINTOP[] = { "WINTOP.VXD", NULL };

int wintop_entry[2];



int main (void)

{

    union REGS regs;

    struct SREGS sregs;



    /* Load and get the entry point of VPICD */

    printf("win_vxd_load(\"%s\") = %i\n", VXDNAME_VPICD[0], win_vxd_load(VXDNAME_VPICD[0]));



    printf("win_vxd_getentry(vpicd_entry, VXDID_VPICD) = %i\n", win_vxd_getentry(vpicd_entry, VXDID_VPICD));

    printf("Entry point via method 1: %x:%x\n", vpicd_entry[0], vpicd_entry[1]);



    /* Getting VxD entry points by name */

    printf("win_vxd_getentrybyname(vpicd_entry2, \"%s\") = %i\n", VXDNAME_VPICD[0], win_vxd_getentrybyname(vpicd_entry2, VXDNAME_VPICD[0]));

    printf("Entry point via method 2: %x:%x\n", vpicd_entry2[0], vpicd_entry2[1]);



    /* Get the VxD's version */



    printf("Getting version using entry point 1...\n");

    memset(&regs, 0, sizeof(regs));

    memset(&sregs, 0, sizeof(sregs));

    regs.x.ax = 0;

    win_vxd_call(vpicd_entry, &regs, &sregs);

    printf("vpicd %i.%i\n", regs.h.ah, regs.h.al);



    printf("Getting version using entry point 2...\n");

    memset(&regs, 0, sizeof(regs));

    memset(&sregs, 0, sizeof(sregs));

    regs.x.ax = 0;

    win_vxd_call(vpicd_entry2, &regs, &sregs);

    printf("vpicd %i.%i\n", regs.h.ah, regs.h.al);



    /* Try something with WinTop (Kernel Toys VxD) */

    /* This shows it has no V86 entry point */

    printf("win_vxd_load(\"%s\") = %i\n", VXDNAME_WINTOP[0], win_vxd_load(VXDNAME_WINTOP[0]));

    printf("win_vxd_getentrybyname(wintop_entry, \"%s\") = %i\n", VXDNAME_WINTOP[0], win_vxd_getentrybyname(wintop_entry, VXDNAME_WINTOP[0]));



    return(EXIT_SUCCESS);

}

