/*
    close.c
    Copyright (C) 1997-1999 by Richard Dawe

    Close-awareness functions - part of libwin

    ---

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <dpmi.h>

#include <libwin/close.h>

/* Operations */
#define OP_CLOSE_ENABLE         0
#define OP_CLOSE_QUERY          1
#define OP_CLOSE_ACKNOWLEDGE    2
#define OP_CLOSE_CANCEL         3

int __inline__ w95_close_op (int func, int value);

int w95_close_enable (void) { return(!w95_close_op(OP_CLOSE_ENABLE, 1)); }
int w95_close_disable (void) { return(!w95_close_op(OP_CLOSE_ENABLE, 0)); }
int w95_close_query (void) { return(w95_close_op(OP_CLOSE_QUERY, 0)); }
int w95_close_acknowledge (void) { return(!w95_close_op(OP_CLOSE_ACKNOWLEDGE, 0)); }
int w95_close_cancel (void) { return(!w95_close_op(OP_CLOSE_CANCEL, 0)); }

/* ----------------
   - w95_close_op -
   ---------------- */

/* This performs all the operations needed for close awareness. */

int __inline__ w95_close_op (int func, int value)
{
    __dpmi_regs r;

    r.h.ah = 0x16;      /* Windows multiplex    */
    r.h.al = 0x8F;      /* VM close functions   */
    r.h.dh = func;      /* Function             */
    r.h.dl = value;     /* Value                */

    __dpmi_int(0x2F, &r);

    return(r.x.ax);
}
