/*
    vxdinfo.c
    Copyright (C) 1997-1999 by Richard Dawe

    VxD IDs and names - part of libwin.

    ---

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>     /* For NULL definition */

/* --- VxD IDs --- */
int VXDID_NULL      = 0x0000;       /* Lots of VxDs have this number    */
int VXDID_VMM       = 0x0001;       /* Virtual Machine Manager          */
int VXDID_VPICD     = 0x0003;       /* Programmable Interrupt Controller*/
int VXDID_VTD       = 0x0005;       /* Virtual timing device            */
int VXDID_V86MMGR   = 0x0006;       /* Virtual 8086 mode device         */
int VXDID_VDD       = 0x000A;       /* Virtual display device           */
int VXDID_VMD       = 0x000C;       /* Virtual mouse device             */
int VXDID_VKD       = 0x000D;       /* Virtual keyboard device          */
int VXDID_VCD       = 0x000E;       /* Virtual comms device             */
int VXDID_VPD       = 0x000F;       /* Virtual printer device           */
int VXDID_VMCPD     = 0x0011;       /* Virtual maths co-pro             */
int VXDID_DOSMGR    = 0x0015;       /* DOS data instancing              */
int VXDID_SHELL     = 0x0017;       /* Shell function access device     */
int VXDID_VNETWARE  = 0x001A;       /* Novell Netware DOSNET replacement*/
int VXDID_VPOWERD   = 0x0026;       /* Power management                 */
int VXDID_VXDLDR    = 0x0027;       /* VXD loader                       */
int VXDID_NDIS      = 0x0028;       /* Network Driver Interface Spec.   */
int VXDID_BIOS      = 0x003D;       /* BIOS VxD                         */
int VXDID_WSOCK     = 0x003E;       /* Winsock                          */
int VXDID_WSIPX     = 0x003F;       /* IPX via Winsock?                 */
int VXDID_VJOYD     = 0x0449;       /* Joystick VXD                     */
int VXDID_VSHARE    = 0x0483;       /* Sharing VXD                      */
int VXDID_VFAT      = 0x0486;       /* VFAT                             */
int VXDID_VCACHE    = 0x048B;       /* Virtual Caching driver           */
int VXDID_NWREDIR   = 0x048E;       /* Netware redirector               */
int VXDID_PPPMAC    = 0x0499;       /* PPP MAC layer?                   */
int VXDID_VDHCP     = 0x049A;       /* Virtual DHCP                     */

/* --- VxD names --- */
/* Do these need to have a specific case? Put them upper-case anyway. */

/* Some VxDs are stored in VMM32.VXD under Win95. */
/*char *VXDNAME_VPOWERD[] = { "", NULL };*/     /* Don't actually know :( */

char *VXDNAME_VPICD[]   = { "VPICD.VXD",    NULL };
char *VXDNAME_VXDLDR[]  = { "VXDLDR.VXD",   NULL };
char *VXDNAME_WSOCK[]   = { "WSOCK.VXD",    NULL };
char *VXDNAME_WSIPX[]   = { "WSIPX.VXD",    NULL };
char *VXDNAME_VJOYD[]   = { "VJOYD.VXD",    NULL };
char *VXDNAME_PPPMAC[]  = { "PPPMAC.VXD",   NULL };
char *VXDNAME_VDHCP[]   = { "VDHCP.VXD",    NULL };
